<?php
global $glob;

// Initialize Cache
$GLOBALS['cache'] = Cache::getInstance();
// Initalise Database class, and fetch default configuration
$GLOBALS['db'] = Database::getInstance($glob);
// Initalise Config class
$GLOBALS['config'] = Config::getInstance($glob);
// Setup the cache more correctly
$GLOBALS['cache']->setup();
// Initialize debug
$GLOBALS['debug'] = Debug::getInstance();
// Initialize sessions
$GLOBALS['session'] = Session::getInstance();
//Check security token
Sanitize::checkToken();
// Initialize Smarty
$GLOBALS['smarty'] = new Smarty();
$GLOBALS['smarty']->allow_php_tag 	= false;
$GLOBALS['smarty']->compile_dir		= CC_SKIN_CACHE_DIR;
$GLOBALS['smarty']->config_dir		= CC_SKIN_CACHE_DIR;
$GLOBALS['smarty']->cache_dir		= CC_SKIN_CACHE_DIR;
//Initialize SSL
$GLOBALS['ssl'] = SSL::getInstance();
//Initialize language
$GLOBALS['language'] = Language::getInstance();
//Initialize hooks
$GLOBALS['hooks'] = HookLoader::getInstance();
//Initialize GUI
$GLOBALS['gui'] = GUI::getInstance(true);
//Initialize SEO
$GLOBALS['seo'] = SEO::getInstance();
//Setup language template
$GLOBALS['language']->setTemplate();
//Initialize Cataglogue
$GLOBALS['catalogue'] = Catalogue::getInstance();

// Define the default timezone
$tz = $GLOBALS['config']->get('config', 'time_zone');
date_default_timezone_set((!empty($tz)) ? $tz : 'UTC');

$GLOBALS['main'] = ACP::getInstance();
$lang = $GLOBALS['language']->getLanguageStrings();

$global_template_file['session_true'] 	= 'main.php';
$global_template_file['session_false'] 	= 'login.php';

foreach ($GLOBALS['hooks']->load('controller.admin') as $hook) include $hook;